﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraGrid1.CreationFilter = new CreationUIElement();
            DataTable dt = new DataTable();
            for (int i = 0; i < 400; i++)
            {
                dt.Columns.Add("Column " + i.ToString(), typeof(string));
            }

            for (int k = 0; k < 1000; k++)
            {
                object[] dr = new object[400];
                for (int i = 0; i < 400; i++)
                {
                    dr[i] = "Test Item " + k.ToString() + " - " + i.ToString();
                }
                dt.Rows.Add(dr);
            }

            ultraGrid1.DataSource = dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].CellActivation = Infragistics.Win.UltraWinGrid.Activation.ActivateOnly;
            e.Layout.Bands[0].Columns[0].CellAppearance.ForeColor = Color.Blue;
            e.Layout.Bands[0].Columns[0].CellAppearance.FontData.Underline = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Bands[0].Columns[0].CellAppearance.Cursor = Cursors.Hand;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Cells[0].Tag ="http://www.google.com/search?hl=en&q=" + e.Row.Cells[0].Value.ToString().Replace(" ", "+");
        }
    }

    public class CreationUIElement : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        private static RowUIElement prevRowUIElement;
        private static int AddHeight;
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is RowColRegionIntersectionUIElement)
            {
                List<UIElement> elementsToRemove = new List<UIElement>();
                List<UIElement> elementsToIncrease = new List<UIElement>();
                foreach (RowUIElement rowUIElement in parent.ChildElements.OfType<RowUIElement>())
                {

                    if (rowUIElement.Rect.Bottom >= parent.Rect.Bottom)
                    {
                        elementsToIncrease.Add(prevRowUIElement);
                        elementsToRemove.Add(rowUIElement);
                        AddHeight = parent.Rect.Bottom - prevRowUIElement.Rect.Bottom;
                        continue;
                    }
                    else
                    {
                        prevRowUIElement = rowUIElement;
                        rowUIElement.Row.Height = 20;
                    }
                }

                
                foreach (UIElement element in elementsToRemove)
                {
                    parent.ChildElements.Remove(element);
                }
                foreach (RowUIElement element in elementsToIncrease)
                {
                    element.Row.Height = element.Row.Height + AddHeight;
                }
                
            }
            if (parent is CellUIElement)
            {
                parent.Rect = new Rectangle(parent.Rect.X, parent.Rect.Y, parent.Rect.Width, parent.Parent.Rect.Height -1);
            }

        }
        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion
    }
}
